package com.web.api.base;

import com.web.api.exception.BusinessException;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.http.HttpServletResponse;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className BaseController
 * @description TODO
 * @date 2019/12/23 14:28
 */
@Slf4j
public class BaseController {
    protected Map<String, Object> returnSuccess() {
        Map<String, Object> map = new HashMap();
        map.put("success", true);
        return map;
    }

    protected Map<String, Object> returnSuccess(String msg) {
        Map<String, Object> map = new HashMap();
        map.put("success", true);
        map.put("message", msg);
        return map;
    }

    protected Map<String, Object> returnError(String meg) {
        Map<String, Object> map = new HashMap();
        map.put("success", false);
        map.put("message", meg);
        return map;
    }

    protected Map<String, Object> returnError(String code, String meg) {
        Map<String, Object> map = new HashMap();
        map.put("success", false);
        map.put("code", code);
        map.put("message", meg);
        return map;
    }

    protected Map<String, Object> returnError(BusinessException e) {
        Map<String, Object> map = new HashMap();
        map.put("success", false);
        map.put("message", e.getMessage());
        return map;
    }

    protected void printStackTraceAsCause(Exception ex, StringBuffer buffer) {
        if (ex != null) {
            String cause = ex.getCause() != null ? ex.getCause().getMessage() : ex.getMessage();
            if (StringUtils.isNotBlank(cause)) {
                if (cause.length() > 500) {
                    buffer.append(cause.substring(0, 500));
                } else {
                    buffer.append(cause);
                }
            }

        }
    }
    public void setResponseHeader(HttpServletResponse response, String fileName) {
        try {
            try {
                fileName = new String(fileName.getBytes(), "ISO8859-1");
            } catch (UnsupportedEncodingException var4) {
                var4.printStackTrace();
            }

            response.setContentType("application/vnd.ms-excel");
            response.setHeader("Content-Disposition", "attachment;filename=" + fileName + ".xls");
            response.addHeader("Pargam", "no-cache");
            response.addHeader("Cache-Control", "no-cache");
        } catch (Exception var5) {
            var5.printStackTrace();
        }

    }
}
