package com.web.api.filter;

import com.web.api.exception.BusinessException;
import com.web.api.exception.UnauthorizedException;
import com.web.api.model.po.SysUser;
import com.web.api.utils.JwtTokenUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * @author 王玉鹏
 * @version 1.0
 * @className TokenInterceptor
 * @description TODO
 * @date 2019/12/23 18:43
 */
@Slf4j
@Component
public class TokenInterceptor implements HandlerInterceptor {


//    @Autowired
//    private UserService userService;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler)throws Exception {
        // 指定允许其他域名访问
        response.setHeader("Access-Control-Allow-Origin", "*");
        // 响应类型
        response.setHeader("Access-Control-Allow-Methods", "POST, GET, DELETE, OPTIONS, DELETE");
        // 响应头设置
        response.setHeader("Access-Control-Allow-Headers", "Content-Type, x-requested-with, X-Custom-Header, HaiYi-Access-Token");

//        if (request.getMethod().equals("OPTIONS")) {
//            response.getWriter().print("OK");
//            response.getWriter().flush();
//            log.info("复杂请求：{}",request.getMethod());
//            return true;
//        }
//        String value = request.getHeader("token");
//        if(StringUtils.isEmpty(value)){
//            log.error("发生错误:{}", "token为空");
//            response.setStatus(401);
//            throw new UnauthorizedException("token为空");
//        }
//       String username = JwtTokenUtils.getUsernameFromToken(value);
//        if (ObjectUtils.isEmpty(username)){
//            log.error("发生错误:{}", "token不合法");
//            response.setStatus(401);
//            throw new UnauthorizedException("token不合法");
//        }
//       SysUser user =userService.selectUserByName(username);
//        if (ObjectUtils.isEmpty(user)){
//            log.error("发生错误:{}", "用户不存在，请重新登录");
//            response.setStatus(401);
//            throw new UnauthorizedException("用户不存在，请重新登录");
//        }
//       log.info("当前登陆用户:{}",username);
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

    }
}
