package com.web.api.service.impl;

import com.web.api.dao.AnswerJobDao;
import com.web.api.model.po.AnswerJob;
import com.web.api.service.AnswerJobService;
import lombok.extern.slf4j.Slf4j;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;


import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * AnswerJob的服务接口的实现类
 * 
 * @author 
 *
 */
@Service
@Slf4j
public class AnswerJobServiceImpl implements AnswerJobService {

	@Autowired
	private AnswerJobDao answerJobDao;


	@Override
	public List<AnswerJob> find(AnswerJob answerJob) {
		return answerJobDao.selectAnswerJobByObj(answerJob);
	}
	@Override
	public AnswerJob findOne(Integer id) {
		return answerJobDao.selectAnswerJobById(id);
	}

	@Override
	public int saveNotNull(AnswerJob answerJob) {
		int res = 0;
		List<AnswerJob> list = answerJobDao.selectAnswerJobByObj(answerJob);
		if (CollectionUtils.isEmpty(list)){
			answerJob.setStatus("0");
			answerJob.setCreateTime(LocalDateTime.now());
			answerJob.setCreateBy("sys");
			log.info("新增job==》{}",answerJob);
			res = answerJobDao.insertNotNullAnswerJob(answerJob);
		}else {
			log.info("更新job==》{}",answerJob);
			answerJob.setUpdateTime(LocalDateTime.now());
			res = answerJobDao.updateNotNullAnswerJobById(answerJob);
		}
		return res;
	}
	@Override
	public int updateNotNullById(AnswerJob answerJob) {
		return answerJobDao.updateNotNullAnswerJobById(answerJob);
	}

	@Override
	public int deleteById(Integer id) {
		return answerJobDao.deleteAnswerJobById(id);
	}

	public static void main(String[] args) {
		List<Integer> list  = Arrays.asList(3, 12, 23, 44, 20, 10, 17, 8);
		System.out.println("---List with even Numbers---");
		List<Integer> evenList = list.stream().filter(i -> i%2 == 0)
				.collect(Collectors.toList());
		evenList.forEach(s -> System.out.print(s+" "));
		System.out.println("\n---List with odd Numbers---");
		list.stream().filter(i -> i%2 == 1)
				.collect(Collectors.toList());
		list.forEach(s -> System.out.print(s+" "));
	}
}